<template>
	<div>
		<v-btn class="px-4" @click="showConfirmationDialog = true"> Reassign </v-btn>
		<v-dialog v-model="showConfirmationDialog" max-width="50em" persistent>
			<v-card>
				<v-dialog :value="hasError" max-width="50em" persistent>
					<v-card>
						<v-toolbar color="grey lighten-2" flat>
							<v-toolbar-title>Error</v-toolbar-title>
						</v-toolbar>
						<v-divider />
						<v-card-text>
							<div class="d-flex justify-center align-center mt-4 mx-2">
								<v-icon color="error">mdi-alert-circle</v-icon>
								<v-divider vertical class="mx-2"></v-divider>
								<p class="mt-0 mb-0">An error occurred while attempting to reassign the group. Please try again.</p>
							</div>
						</v-card-text>
						<v-divider />
						<v-card-actions class="d-flex flex-wrap justify-end">
							<v-btn text rounded @click="acknowledgeReassignError()" :disabled="isLoading">Ok</v-btn>
						</v-card-actions>
					</v-card>
				</v-dialog>
				<v-toolbar color="grey lighten-2" flat>
					<v-toolbar-title>Assign {{ field.name }} to Group</v-toolbar-title>
				</v-toolbar>
				<v-divider />
				<v-card-text class="py-4">
					<div class="d-flex justify-center align-center mt-4 mx-2">
						<v-icon color="warning">mdi-exclamation-thick</v-icon>
						<v-divider vertical class="mx-2"></v-divider>
						<v-select
							v-model="selectedGroup"
							:items="groupOptions"
							:item-text="(group) => `${group.name} - ${group.path}`"
							item-value="id"
							label="Choose Group"
							no-data-text="You lack permission to assign this field to other groups."
						></v-select>
					</div>
				</v-card-text>
				<v-divider />
				<v-card-actions class="d-flex flex-wrap justify-end">
					<v-btn class="mr-2" text rounded @click="showConfirmationDialog = false" :disabled="isLoading">Cancel</v-btn>
					<v-btn color="warning" text rounded @click="handleConfirmReassign" :loading="isLoading"
						>Confirm Reassign</v-btn
					>
				</v-card-actions>
			</v-card>
		</v-dialog>
	</div>
</template>

<script lang="ts">
import { defineComponent, ref } from '@vue/composition-api';
import { Group, Field } from '@/store/types';
import { useReassign } from '@/store/modules/reassign';

export default defineComponent({
	props: {
		field: {
			required: true,
			type: Object as () => Field,
		},
		groups: {
			required: true,
			type: Array as () => Group[],
		},
	},
	setup(props, { root }) {
		const selectedGroup = ref(null);
		const showConfirmationDialog = ref(false);
		const { isLoading, hasError } = useReassign(root.$store);
		return {
			handleConfirmReassign: async () => {
				const success = await root.$store.dispatch('reassign/requestReassign', {
					groupId: selectedGroup.value,
					fieldId: props.field.id,
				});
				if (success) {
					root.$store.dispatch('resources/getAllResources');
					showConfirmationDialog.value = false;
				}
			},
			acknowledgeReassignError: () => root.$store.dispatch('reassign/acknowledgeReassignError'),
			showConfirmationDialog,
			selectedGroup,
			groupOptions: props.groups.filter((group) => group.id !== props.field.meta.groupId),
			isLoading,
			hasError,
		};
	},
});
</script>

<style></style>
